Package: scatterbar
Title: Scattered Stacked Bar Chart Plots
Type: Package
Version: 0.1.0
Imports: magrittr, dplyr, tidyr, ggplot2
Authors@R: 
    c(person("Dee", "Velazquez", email = "dvelazq5@jhu.edu", 
    role = c("aut", "cre"), 
    comment = c(ORCID = "0009-0004-4380-4794")),
    person("Jean", "Fan", email = "jeanfan@jhu.edu", 
    role = c("aut", "rev"), 
    comment = c(ORCID = "0000-0002-0212-5451")))
URL: https://github.com/JEFworks-Lab/scatterbar,
        http://jef.works/scatterbar/
BugReports: https://github.com/JEFworks-Lab/scatterbar/issues
Description: Provides a powerful and flexible tool for visualizing proportional data across spatially resolved contexts. By combining the concepts of scatter plots and stacked bar charts, 'scatterbar' allows users to create scattered bar chart plots, which effectively display the proportions of different categories at each (x, y) location. This visualization is particularly useful for applications where understanding the distribution of categories across spatial coordinates is essential. This package features automatic determination of optimal scaling factors based on data, customizable scaling and padding options for both x and y axes, flexibility to specify custom colors for each category, options to customize the legend title, and integration with 'ggplot2' for robust and high-quality visualizations. For more details, see Velazquez et al. (2024) <doi:10.1101/2024.08.14.606810>.
License: GPL-3
Encoding: UTF-8
LazyData: FALSE
RoxygenNote: 7.3.2
Depends: R (>= 3.5.0)
Suggests: knitr, rmarkdown, patchwork
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2024-11-22 22:47:37 UTC; deev
Author: Dee Velazquez [aut, cre] (<https://orcid.org/0009-0004-4380-4794>),
  Jean Fan [aut, rev] (<https://orcid.org/0000-0002-0212-5451>)
Maintainer: Dee Velazquez <dvelazq5@jhu.edu>
Repository: CRAN
Date/Publication: 2024-11-25 11:50:02 UTC
Built: R 4.6.0; ; 2026-04-30 03:04:42 UTC; unix

Package: scatterbar
Title: Scattered Stacked Bar Chart Plots
Type: Package
Version: 0.1.0
Imports: magrittr, dplyr, tidyr, ggplot2
Authors@R: 
    c(person("Dee", "Velazquez", email = "dvelazq5@jhu.edu", 
    role = c("aut", "cre"), 
    comment = c(ORCID = "0009-0004-4380-4794")),
    person("Jean", "Fan", email = "jeanfan@jhu.edu", 
    role = c("aut", "rev"), 
    comment = c(ORCID = "0000-0002-0212-5451")))
URL: https://github.com/JEFworks-Lab/scatterbar,
        http://jef.works/scatterbar/
BugReports: https://github.com/JEFworks-Lab/scatterbar/issues
Description: Provides a powerful and flexible tool for visualizing proportional data across spatially resolved contexts. By combining the concepts of scatter plots and stacked bar charts, 'scatterbar' allows users to create scattered bar chart plots, which effectively display the proportions of different categories at each (x, y) location. This visualization is particularly useful for applications where understanding the distribution of categories across spatial coordinates is essential. This package features automatic determination of optimal scaling factors based on data, customizable scaling and padding options for both x and y axes, flexibility to specify custom colors for each category, options to customize the legend title, and integration with 'ggplot2' for robust and high-quality visualizations. For more details, see Velazquez et al. (2024) <doi:10.1101/2024.08.14.606810>.
License: GPL-3
Encoding: UTF-8
LazyData: FALSE
RoxygenNote: 7.3.2
Depends: R (>= 3.5.0)
Suggests: knitr, rmarkdown, patchwork
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2024-11-22 22:47:37 UTC; deev
Author: Dee Velazquez [aut, cre] (<https://orcid.org/0009-0004-4380-4794>),
  Jean Fan [aut, rev] (<https://orcid.org/0000-0002-0212-5451>)
Maintainer: Dee Velazquez <dvelazq5@jhu.edu>
Repository: CRAN
Date/Publication: 2024-11-25 11:50:02 UTC
Built: R 4.6.0; ; 2026-04-26 21:23:47 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# scatterbar

<!-- badges: start -->
<!-- badges: end -->

`scatterbar` is an open-source R package for displaying proportional data across spatially resolved contexts. This is the `scatterbar` R documentation
website. Questions, suggestions, or problems should be submitted as
[GitHub issues](https://github.com/JEFworks-Lab/scatterbar/issues).

<p>

<img src="https://github.com/JEFworks-Lab/scatterbar/blob/main/images/scatterbar_logo_hex.png?raw=true" align="center" height="300" style="float: center; height:300px;"/>

</p>

## Overview

By combining the concepts of scatter plots and stacked bar charts,
`scatterbar` allows users to visualize variations in proportional data
data and compare across different spatial locations.

<p align="center">

<img src="https://github.com/JEFworks-Lab/scatterbar/blob/main/images/scatterbar_example.png?raw=true" height="600"/>

</p>

## Installation

To install `scatterbar`from GitHub, we recommend using `remotes`:

``` r
require(remotes)
remotes::install_github('JEFworks-Lab/scatterbar')
```

## Tutorials

- [Customizing
  Scatterbar](https://jef.works/scatterbar/articles/customizing_scatterbar.html)
- [Getting Started With
  Scatterbar](https://jef.works/scatterbar/articles/getting-started-with-scatterbars.html)
- [Using Scatterbar With Visium Files](https://jef.works/scatterbar/articles/using-scatterbar-with-visium.html)
- [Visualizing Multiple Datasets](https://jef.works/scatterbar/articles/visualizing-multiple-datasets.html)
- [Flipping Scatterbar Oreintations](https://jef.works/scatterbar/articles/flipping-scatterbar-oreintations.html)

## Citation

Our preprint describing `scatterbar` is available on *bioRxiv*:

[Velazquez D. et al. (2024), "scatterbar: an R package for visualizing proportional data across spatially resolved coordinates", *bioRxiv*](https://doi.org/10.1101/2024.08.14.606810)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
# Load packages and example adult mouse brain dataset
library(scatterbar)
library(ggplot2)

data("adult_mouse_brain_ffpe")

## ----flipped plot-------------------------------------------------------------
# Flip the x and y columns of the position data
flipped_pos <- adult_mouse_brain_ffpe$pos[, c(2,1)]
# Rename the columns to ensure the position data has the correct column names
colnames(flipped_pos) <- c('x','y')
# Create the scatterbar plot with the flipped position data
start.time <- Sys.time()
scatterbar::scatterbar(adult_mouse_brain_ffpe$prop, 
                       flipped_pos, padding_x = 0.3, padding_y = 0.3,
                       size_x = 220, size_y = 220,
                       legend_title = "Cell Types") + coord_fixed()
end.time <- Sys.time()
print(end.time - start.time)

## ----flipped orientation------------------------------------------------------
# Create the scatterbar plot with the flipped scatterbar oreintation
start.time <- Sys.time()
scatterbar::scatterbar(adult_mouse_brain_ffpe$prop, 
                       flipped_pos, padding_x = 0.3, padding_y = 0.3,
                       size_x = 220, size_y = 220,
                       legend_title = "Cell Types") + coord_fixed() + coord_flip()
end.time <- Sys.time()
print(end.time - start.time)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(scatterbar)
library(ggplot2)

data("mOB")
data("adult_mouse_brain_ffpe")

# Basic scatterbar plot with default settings
p1 <- scatterbar(mOB$data, mOB$xy) + coord_fixed()
p2 <- scatterbar(adult_mouse_brain_ffpe$prop, adult_mouse_brain_ffpe$pos) + coord_fixed()

## ----patchwork----------------------------------------------------------------
library(patchwork)
p1 + p2

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(scatterbar)
library(ggplot2)
data("adult_mouse_brain_ffpe")

plot(adult_mouse_brain_ffpe$pos)
head(adult_mouse_brain_ffpe$prop)

start.time <- Sys.time()
scatterbar(
  adult_mouse_brain_ffpe$prop,
  adult_mouse_brain_ffpe$pos,
  size_x = 220,
  size_y = 220,
  legend_title = "Cell Types"
) + coord_fixed()

end.time <- Sys.time()
print(end.time - start.time)

## ----shiftorder---------------------------------------------------------------
start.time <- Sys.time()
custom_colors <- c('1'= '#5d6f99',
    '2' = '#985a39',
    '3' =  '#d6589a',
    '4' = '#4d1395',
    '5' = '#b5ef27',
    '6' = '#77d5bc',
    '7' = '#7830d2',
    '8' ='#b43b59',
    '9' = '#1c40b1',
    '10' = "#FF5733",
    '11' = '#FFFF00',
    '12' = '#f4a6f1')
scatterbar::scatterbar(adult_mouse_brain_ffpe$prop[, c(2,3,4,11,5,6,10,7,8,1,9, 12)], adult_mouse_brain_ffpe$pos, size_x = 220, size_y = 220, padding_x = 0.1, padding_y = 0.1, legend_title = 'Cell Type', colors = custom_colors) +
  geom_point(data=adult_mouse_brain_ffpe$pos, mapping=aes(x=x, y=y), size = 0.1) +
  theme_bw() + ylab('y') + ggplot2::coord_fixed()
end.time <- Sys.time()
print(end.time - start.time)

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)

## ----simulate-----------------------------------------------------------------

# Load the scatterbar library
library(scatterbar)

# Define positional data: coordinates (x, y) for each spot
pos <- data.frame(x = c(1,1,2,2),
                  y = c(1,2,1,2))

# Define proportional data: proportions of different categories (p1, p2, p3, p4) at each spot
prop <- matrix(c(0.5, 0.5,  0,   0,
                 0.5, 0,    0,   0.5,
                 0,   0.5,  0.5, 0,
                 0,   0,    0.5, 0.5), nrow=4)

# Assign row names to both positional and proportional data, representing the spot identifiers
rownames(pos) <- rownames(prop) <- c('a','b','c','d')

# Assign column names to the proportional data, representing the categories/groups
colnames(prop) <- c('Dogs', 'Cats', 'Fish', 'Snakes')

# Print out the positional data
print(pos)

# Print out the positional data
print(prop)

## ----pressure-----------------------------------------------------------------

# Basic scatterbar plot with default settings
scatterbar(prop, pos)

# Scatterbar plot with a black-and-white theme and customized y-axis label
scatterbar(prop, pos) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with fixed x and y scale factors of 1 (size_x and size_y)
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with padding applied to the x and y axes, making the tiles slightly smaller
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with flipped coordinates, so that x and y axes are interchanged
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + 
  ggplot2::coord_flip()

# Scatterbar plot with customized legend title
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals") +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot using the custom colors
# Define a custom set of colors for the categories
custom_colors <- c("#FF0000",  # Red
                   "#00FF00",  # Green
                   "#0000FF",  # Blue
                   "#A020F0")  # Purple
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with title
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + ggplot2::labs(title="Favorite Animals Among Classrooms")

# Scatterbar plot modifying the order of categories plotted 
scatterbar(prop[, c("Fish", "Snakes", "Cats", "Dogs")], pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + ggplot2::labs(title="Favorite Animals Among Classrooms")

## ----test---------------------------------------------------------------------
# Define a new proportional data matrix where proportions do not sum to 1
prop <- matrix(c(0.1, 0.2,  0,   0,
                 0.1, 0,    0,   0.4,
                 0,   0.2,  0.3, 0,
                 0,   0,    0.3, 0.4), nrow=4)

# Assign row names representing the spots
rownames(prop) <- c('a','b','c','d')

# Assign column names representing the categories/groups
colnames(prop) <- c('Dogs', 'Cats', 'Fish', 'Snakes')

# Print the new proportional data
print(prop)

# Create a scatterbar plot with the new data
scatterbar(prop, pos)

# Customize the scatterbar plot using a black-and-white theme and customized y-axis label
scatterbar(prop, pos) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Create a scatterbar plot with fixed x and y scales and customized theme
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Apply padding to the scatterbar plot to make the tiles smaller
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with flipped coordinates
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + 
  ggplot2::coord_flip()

# Scatterbar plot with customized legend title
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals") +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot using the custom colors
# Define a custom set of colors for the categories
custom_colors <- c("#FF0000",  # Red
                   "#00FF00",  # Green
                   "#0000FF",  # Blue
                   "#A020F0")  # Purple
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with title
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + ggplot2::labs(title="Favorite Animals Among Classrooms")

# Scatterbar plot modifying the order of categories plotted 
scatterbar(prop[, c("Fish", "Snakes", "Cats", "Dogs")], pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + ggplot2::labs(title="Favorite Animals Among Classrooms")

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)

## ----setup--------------------------------------------------------------------
library(scatterbar)
data("mOB")

plot(mOB$xy)
head(mOB$data)

start.time <- Sys.time()
scatterbar::scatterbar(mOB$data, mOB$xy) + ggplot2::coord_fixed()
end.time <- Sys.time()
print(end.time - start.time)


## ----shiftorder---------------------------------------------------------------
library(ggplot2)
start.time <- Sys.time()
scatterbar::scatterbar(mOB$data[, c(2,3,4,5,6,7,8,1)], mOB$xy, size_x = 1, size_y = 1, padding_x = 0.1, padding_y = 0.1) +
  geom_point(data=mOB$xy, mapping=aes(x=x, y=y)) +
  theme_bw() + ylab('y') + ggplot2::coord_fixed()
end.time <- Sys.time()
print(end.time - start.time)

---
title: "Getting started with scatterbars"
author: "Dee Velazquez and Jean Fan"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Getting started with scatterbars}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(echo = TRUE)
```
# Getting started with scatterbars

Below is how to use scatterbar from the provided spatial transcriptomic data from the mouse olfactory bulb tissue sample.
```{r setup}
library(scatterbar)
data("mOB")

plot(mOB$xy)
head(mOB$data)

start.time <- Sys.time()
scatterbar::scatterbar(mOB$data, mOB$xy) + ggplot2::coord_fixed()
end.time <- Sys.time()
print(end.time - start.time)

```

We can change the order of how each bar is laid out by changing the order of the cell-type proportion matrix of spatial transcriptomic data. We can also combine scatterbar with other ggplot geoms and customization!

```{r shiftorder}
library(ggplot2)
start.time <- Sys.time()
scatterbar::scatterbar(mOB$data[, c(2,3,4,5,6,7,8,1)], mOB$xy, size_x = 1, size_y = 1, padding_x = 0.1, padding_y = 0.1) +
  geom_point(data=mOB$xy, mapping=aes(x=x, y=y)) +
  theme_bw() + ylab('y') + ggplot2::coord_fixed()
end.time <- Sys.time()
print(end.time - start.time)
```

---
title: "Customizing scatterbar"
author: "Dee Velazquez and Jean Fan"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Customizing scatterbar}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```
# Customizing scatterbar

Below, we will simulate some data for demo purposes. We will create a small dataset to demonstrate the `scatterbar` function.

```{r simulate}

# Load the scatterbar library
library(scatterbar)

# Define positional data: coordinates (x, y) for each spot
pos <- data.frame(x = c(1,1,2,2),
                  y = c(1,2,1,2))

# Define proportional data: proportions of different categories (p1, p2, p3, p4) at each spot
prop <- matrix(c(0.5, 0.5,  0,   0,
                 0.5, 0,    0,   0.5,
                 0,   0.5,  0.5, 0,
                 0,   0,    0.5, 0.5), nrow=4)

# Assign row names to both positional and proportional data, representing the spot identifiers
rownames(pos) <- rownames(prop) <- c('a','b','c','d')

# Assign column names to the proportional data, representing the categories/groups
colnames(prop) <- c('Dogs', 'Cats', 'Fish', 'Snakes')

# Print out the positional data
print(pos)

# Print out the positional data
print(prop)
```

Here, we will create scatterbar plots using the scatterbar function and demonstrate various customization options using ggplot2.

```{r pressure}

# Basic scatterbar plot with default settings
scatterbar(prop, pos)

# Scatterbar plot with a black-and-white theme and customized y-axis label
scatterbar(prop, pos) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with fixed x and y scale factors of 1 (size_x and size_y)
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with padding applied to the x and y axes, making the tiles slightly smaller
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with flipped coordinates, so that x and y axes are interchanged
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + 
  ggplot2::coord_flip()

# Scatterbar plot with customized legend title
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals") +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot using the custom colors
# Define a custom set of colors for the categories
custom_colors <- c("#FF0000",  # Red
                   "#00FF00",  # Green
                   "#0000FF",  # Blue
                   "#A020F0")  # Purple
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with title
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + ggplot2::labs(title="Favorite Animals Among Classrooms")

# Scatterbar plot modifying the order of categories plotted 
scatterbar(prop[, c("Fish", "Snakes", "Cats", "Dogs")], pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + ggplot2::labs(title="Favorite Animals Among Classrooms")
```

What if my proportions don't add up to 1?

```{r test}
# Define a new proportional data matrix where proportions do not sum to 1
prop <- matrix(c(0.1, 0.2,  0,   0,
                 0.1, 0,    0,   0.4,
                 0,   0.2,  0.3, 0,
                 0,   0,    0.3, 0.4), nrow=4)

# Assign row names representing the spots
rownames(prop) <- c('a','b','c','d')

# Assign column names representing the categories/groups
colnames(prop) <- c('Dogs', 'Cats', 'Fish', 'Snakes')

# Print the new proportional data
print(prop)

# Create a scatterbar plot with the new data
scatterbar(prop, pos)

# Customize the scatterbar plot using a black-and-white theme and customized y-axis label
scatterbar(prop, pos) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Create a scatterbar plot with fixed x and y scales and customized theme
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Apply padding to the scatterbar plot to make the tiles smaller
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with flipped coordinates
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + 
  ggplot2::coord_flip()

# Scatterbar plot with customized legend title
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals") +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot using the custom colors
# Define a custom set of colors for the categories
custom_colors <- c("#FF0000",  # Red
                   "#00FF00",  # Green
                   "#0000FF",  # Blue
                   "#A020F0")  # Purple
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y')

# Scatterbar plot with title
scatterbar(prop, pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + ggplot2::labs(title="Favorite Animals Among Classrooms")

# Scatterbar plot modifying the order of categories plotted 
scatterbar(prop[, c("Fish", "Snakes", "Cats", "Dogs")], pos, 
                  size_x = 1, size_y = 1, 
                  padding_x = 0.1, padding_y = 0.1, legend_title= "Animals", colors=custom_colors) +
  ggplot2::theme_bw() + ggplot2::ylab('y') + ggplot2::labs(title="Favorite Animals Among Classrooms")
```

---
title: "Flipping scatterbar oreintations and positions"
author: "Dee Velazquez and Jean Fan"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Flipping scatterbar oreintations and positions}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
# Flipping scatterbar oreintations and positions

This tutorial demonstrates how to change the orientation of a scatterbar plot using the `scatterbar` package. Specifically, we will flip the x and y coordinates to create an alternative view of the data.

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
# Load packages and example adult mouse brain dataset
library(scatterbar)
library(ggplot2)

data("adult_mouse_brain_ffpe")
```
Here, we flip the x and y coordinates in the `pos` data frame to change the orientation of the whole scatterbar plot, such that the adult mouse brain is now displayed horizontally.

```{r flipped plot}
# Flip the x and y columns of the position data
flipped_pos <- adult_mouse_brain_ffpe$pos[, c(2,1)]
# Rename the columns to ensure the position data has the correct column names
colnames(flipped_pos) <- c('x','y')
# Create the scatterbar plot with the flipped position data
start.time <- Sys.time()
scatterbar::scatterbar(adult_mouse_brain_ffpe$prop, 
                       flipped_pos, padding_x = 0.3, padding_y = 0.3,
                       size_x = 220, size_y = 220,
                       legend_title = "Cell Types") + coord_fixed()
end.time <- Sys.time()
print(end.time - start.time)
```

We can also change the orientation of the stacked bar charts themselves and how they are displayed. With `coord_flip()`, the adult mouse brain is now displayed vertically once more, but the stacked bar charts are now displayed horizontally.  

```{r flipped orientation}
# Create the scatterbar plot with the flipped scatterbar oreintation
start.time <- Sys.time()
scatterbar::scatterbar(adult_mouse_brain_ffpe$prop, 
                       flipped_pos, padding_x = 0.3, padding_y = 0.3,
                       size_x = 220, size_y = 220,
                       legend_title = "Cell Types") + coord_fixed() + coord_flip()
end.time <- Sys.time()
print(end.time - start.time)
```

---
title: "Using scatterbar with Visium data"
author: "Dee Velazquez and Jean Fan"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Using scatterbar with Visium data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```
# Using scatterbar with Visium data

Below is how to use `scatterbar` from the provided Visium dataset of an FFPE preserved adult mouse brain partial coronal section from 10X Genomics.
```{r setup}
library(scatterbar)
library(ggplot2)
data("adult_mouse_brain_ffpe")

plot(adult_mouse_brain_ffpe$pos)
head(adult_mouse_brain_ffpe$prop)

start.time <- Sys.time()
scatterbar(
  adult_mouse_brain_ffpe$prop,
  adult_mouse_brain_ffpe$pos,
  size_x = 220,
  size_y = 220,
  legend_title = "Cell Types"
) + coord_fixed()

end.time <- Sys.time()
print(end.time - start.time)
```

Just like with the mOB data, we can change the order of how each bar is laid out by changing the order of the cell-type proportion matrix and combine `scatterbar` with other ggplot geoms and customization.
```{r shiftorder}
start.time <- Sys.time()
custom_colors <- c('1'= '#5d6f99',
    '2' = '#985a39',
    '3' =  '#d6589a',
    '4' = '#4d1395',
    '5' = '#b5ef27',
    '6' = '#77d5bc',
    '7' = '#7830d2',
    '8' ='#b43b59',
    '9' = '#1c40b1',
    '10' = "#FF5733",
    '11' = '#FFFF00',
    '12' = '#f4a6f1')
scatterbar::scatterbar(adult_mouse_brain_ffpe$prop[, c(2,3,4,11,5,6,10,7,8,1,9, 12)], adult_mouse_brain_ffpe$pos, size_x = 220, size_y = 220, padding_x = 0.1, padding_y = 0.1, legend_title = 'Cell Type', colors = custom_colors) +
  geom_point(data=adult_mouse_brain_ffpe$pos, mapping=aes(x=x, y=y), size = 0.1) +
  theme_bw() + ylab('y') + ggplot2::coord_fixed()
end.time <- Sys.time()
print(end.time - start.time)
```

---
title: "Visualizing multiple datasets with scatterbar"
author: "Dee Velazquez and Jean Fan"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Visualizing multiple datasets with scatterbar}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
# Visualizing multiple datasets with scatterbar

This tutorial demonstrates how to visualize multiple datasets together, utilizing the package `patchwork`.
```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

Below we can load in our datasets provided by `scatterbar` and create the respective scatterbars using those datasets and save them to a variable.
```{r setup}
library(scatterbar)
library(ggplot2)

data("mOB")
data("adult_mouse_brain_ffpe")

# Basic scatterbar plot with default settings
p1 <- scatterbar(mOB$data, mOB$xy) + coord_fixed()
p2 <- scatterbar(adult_mouse_brain_ffpe$prop, adult_mouse_brain_ffpe$pos) + coord_fixed()
```

We can then load in `patchwork` and visualize both scatterbars in one plot.
```{r patchwork}
library(patchwork)
p1 + p2

```
